<template>
    <div class="notification">
        <div class="notification-alert" v-if="notificationAlert">
            <!-- "A conversation has requested to transfer to you." -->
            <div v-if="notificationList[notificationList.length - 1].transfer">
                <div
                    @click="redirect()"
                    class="notification-list row justify-center items-center"
                    v-if="
                        notificationList[notificationList.length - 1].transfer
                            .type == 2
                    "
                >
                    <div class="col-2">
                        <q-icon
                            size="md"
                            name="img:icons\notification.png"
                            @click="redirect()"
                        ></q-icon>
                    </div>
                    <div class="col-8 row">
                        <span class="col-12">{{ $t('notification.new') }}</span>
                        <span class="col-12">
                            A conversation has requested to transfer to you.
                        </span>
                    </div>
                </div>
                <div
                    @click="redirect()"
                    class="notification-list row justify-center items-center"
                    v-if="
                        notificationList[notificationList.length - 1].transfer
                            .type == 1
                    "
                >
                    <div class="col-2">
                        <q-icon
                            size="md"
                            name="img:icons\notification.png"
                            @click="redirect()"
                        ></q-icon>
                    </div>
                    <div class="col-8 row">
                        <span class="col-12">{{ $t('notification.new') }}</span>
                        <span class="col-12">
                            A conversation has requested from you
                        </span>
                    </div>
                </div>
                <div class="exit">
                    <q-icon @click="close()" size="sm" name="close"></q-icon>
                </div>
            </div>

            <!-- New message notification -->
            <div
                v-else-if="
                    notificationList[notificationList.length - 1].user &&
                    notificationList[notificationList.length - 1]
                        .conversationId != selectedConversationID
                "
            >
                <div
                    class="notification-list row justify-center items-center"
                    @click="
                        ticketIDLinkPressed(
                            notificationList[notificationList.length - 1]
                                .conversationId
                        )
                    "
                >
                    <div class="col-2">
                        <q-icon
                            size="md"
                            name="img:icons\notification.png"
                            @click="
                                ticketIDLinkPressed(
                                    notificationList[
                                        notificationList.length - 1
                                    ].conversationId
                                )
                            "
                        ></q-icon>
                    </div>
                    <div class="col-8 row">
                        <span class="col-12">{{ $t('notification.new') }}</span>
                        <span class="col-12">
                            {{
                                notificationList[notificationList.length - 1]
                                    .user.name
                            }}
                            {{ $t('notification.message') }}
                        </span>
                    </div>
                </div>
                <div class="exit" @click="close()">
                    <q-icon size="sm" name="close"></q-icon>
                </div>
            </div>

            <!-- "A chat has been receive" -->
            <div
                @click="redirect()"
                class="notification-list row justify-center items-center"
                v-if="
                    notificationList[notificationList.length - 1].conversation
                "
            >
                <div class="col-2">
                    <q-icon
                        size="md"
                        name="img:icons\notification.png"
                        @click="redirect()"
                    ></q-icon>
                </div>
                <div class="col-8 row">
                    <span class="col-12">{{ $t('notification.new') }}</span>
                    <span class="col-12">A chat has been receive</span>
                </div>
                <div class="exit" @click="close()">
                    <q-icon size="sm" name="close"></q-icon>
                </div>
            </div>
        </div>

        <!-- Notification Alert Button -->
        <!-- <q-btn
            round
            dense
            color="primary"
            size="md"
            icon="notifications"
            class="float-right"
        /> -->

        <div class="notification-panel" v-if="notificationPanel">
            <div class="notification-pointer"></div>
            <div class="row q-pt-lg q-px-lg">
                <div class="col-6">
                    <p class="font-16">Notifications</p>
                </div>
                <div class="col-6">
                    <p class="float-right font-12 text-318BDD">Clear all</p>
                </div>
            </div>

            <!-- LIST -->
            <div class="row">
                <div class="col-12">
                    <q-list class="q-pa-md">
                        <q-item
                            v-for="(list, index) in notificationList"
                            :key="'notification-' + index"
                        >
                            <q-item-section
                                avatar
                                class="mw-auto"
                                v-if="list.status == 1"
                            >
                                <div class="notification-unread"></div>
                            </q-item-section>
                            <q-item-section avatar>
                                <q-img
                                    class="border-radius-50"
                                    :src="
                                        list.avatar
                                            ? list.avatar
                                            : '/images/default.png'
                                    "
                                />
                            </q-item-section>
                            <q-item-section>
                                <q-item-label>
                                    <span class="font-14">
                                        {{ list.user.name }}
                                        {{ $t('notification.message') }}
                                    </span>
                                </q-item-label>
                                <q-item-label>
                                    <span class="text-6B85E8 font-10">
                                        {{ list.createdAt }}
                                    </span>
                                </q-item-label>
                            </q-item-section>
                            <q-item-section top side>
                                <q-btn
                                    class="gt-xs border-radius-10"
                                    size="12px"
                                    label="View"
                                    color="white"
                                    text-color="black"
                                />
                            </q-item-section>
                        </q-item>
                    </q-list>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import { useStore } from 'src/store';
import { useQuasar } from 'quasar';
import { defineComponent, reactive, onMounted, watch, computed } from 'vue';
import { mapGetters } from 'vuex';
import moment from 'moment';
import { useRouter } from 'vue-router';

export default defineComponent({
    name: 'Notifications',
    computed: {
        ...mapGetters({
            notificationAlert: 'notification/getAlert',
            notificationPanel: 'notification/getPanel',
            notificationList: 'notification/getList',
            user: 'user/getUser',
            selectedConversationID: 'conversation/getSelectedConversationID'
        })
    },
    setup() {
        const $q = useQuasar();
        const store = useStore();
        const router = useRouter();

        const conversationList = computed(() => {
            return store.state.conversation.conversationsList;
        });

        // data
        let state = reactive({
            alert: computed(() => {
                return store.state.notification.alert;
            }),
            notificationList: [
                {
                    id: '1',
                    createdAt: moment.utc(Date()).local().fromNow(),
                    avatar: '',
                    message: 'James has requested to get the task',
                    status: 1
                },
                {
                    id: '2',
                    createdAt: moment.utc(Date()).local().fromNow(),
                    avatar: '',
                    message: 'Steven wants to transfer a task to you',
                    status: 0
                }
            ]
        });

        watch(store.state.notification.list, (currentValue) => {
            if (currentValue) {
                setTimeout(function () {
                    close();
                }, 4000);
            }
        });

        const alerts = [
            {
                color: 'white',
                multiLine: true,
                message: 'New notification',
                caption: 'James request to handover your task'
            }
        ];

        // methods
        const setNotificationPanel = () => {
            store.dispatch('notification/setPanel');
        };

        const close = () => {
            store.dispatch('notification/closePanel');
        };
        const redirect = () => {
            router.push('/helpdesk/');
            store.dispatch('menu/setSelectedShortcut', 'ongoing');
            store.dispatch('notification/setAlert');
        };

        const convo = (convo: any) => {
            const findIndex = conversationList.value.findIndex(
                (element: any) => element.id == convo.id
            );
            //Force Transfer is same
            return 1;
        };
        const ticketIDLinkPressed = (id: any) => {
            store.dispatch('notification/setAlert');
            const findIndex = conversationList.value.findIndex(
                (element: any) => element.id == id
            );
            let convo = conversationList.value[findIndex];

            router.push({
                path: '/chat',
                query: {
                    conversationId: id,
                    businessId: store.state.business.businessID,
                    branchId: store.state.branch.branch.id
                }
            });
            store.dispatch('menu/clearPage');
            store.dispatch('menu/setPage', 'helpdesk');
            store.dispatch('menu/setSelectedShortcut', 'ongoing');
            store.dispatch('conversation/setTicketConversation', convo);
        };

        return {
            state,
            close,
            setNotificationPanel,
            redirect,
            convo,
            conversationList,
            ticketIDLinkPressed,
            showNotif(position: any) {
                const { color, multiLine, caption, message } =
                    alerts[Math.floor(Math.random() * 10) % alerts.length];

                $q.notify({
                    color,
                    message,
                    textColor: 'black',
                    icon: 'notifications',
                    position,
                    multiLine,
                    timeout: 5000,
                    caption,
                    actions: [{ label: 'X', color: 'black' }]
                });
            }
        };
    }
});
</script>
